
import java.lang.*;
import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.bluetooth.*;

public class BlueServer extends BlueTMIDlet {
    
    /**
     * Creates a server object. Accepts a single
     * connection from a client and prints the data
     * sent from the client to the screen.
     */
    
    int x, y;
    String text;
    DataInputStream in;
    StreamConnection conn;
    StreamConnectionNotifier notifier;
    
    Minicanvas mc;
    
    public void run() {
        
        // Create a Form and add the Exit command to the Form
        Form f = new Form("Server");
        f.addCommand(new Command("Exit", Command.EXIT, 1));
        f.setCommandListener(this);
        //Display.getDisplay(this).setCurrent(f);
        
        mc = new Minicanvas();
        
        new Thread(mc).start();
        
        Display.getDisplay(this).setCurrent(mc);
        
        try {
            // Make the local device discoverable for the
            // client to locate
            LocalDevice local = LocalDevice.getLocalDevice();
            if (!local.setDiscoverable(DiscoveryAgent.GIAC)) {
                f.append("Failed to change to the " + "discoverable mode");
                return;
            }
            
            // Create a server connection object to accept
            // a connection from a client
            notifier = (StreamConnectionNotifier)
            Connector.open("btspp://localhost:" + "86b4d249fb8844d6a756ec265dd1f6a3");
            
            // Accept a connection from the client
            conn = notifier.acceptAndOpen();
            // Open the input to read data from
            in = conn.openDataInputStream();
            
            while(true) {
                mc.x = in.readInt();
                mc.y = in.readInt();
                
                text = "(" + mc.x + ", " + mc.y + ")";
                // Add the text sent from the client to the Form
                f.deleteAll();
                f.append(text);
                try {
                    Thread.sleep(30);
                } catch (InterruptedException ie) {}
            }
            
            // Close all open resources
            // in.close();
            //  conn.close();
            //  notifier.close();
        } catch (BluetoothStateException e) {
            f.append("BluetoothStateException: ");
            f.append(e.getMessage());
        } catch (IOException e) {
            f.append("IOException: ");
            f.append(e.getMessage());
        }
    }
}