/*
 * s1controlCanvas.java
 *
 * Created on 2006~0905 PG, U5:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author Freddy
 */

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import javax.microedition.io.*;
import java.io.*;

public class s1controlCanvas extends GameCanvas implements CommandListener, Runnable {
    
    int x, y;
    Sprite s;
    
    /** Creates a new instance of s1controlCanvas */
    public s1controlCanvas() {
         super(true);
         
         try {
            
            x = 0; y = 0;
            createSprite();
            s1controlCommClient cc = new s1controlCommClient(this);
            Thread t = new Thread(cc);
            t.start();
            
            Thread t2 = new Thread(this);
            t2.start();
            
            jbInit();
            
            
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    
    public int getX() {
        return s.getX();
    }
    
    public int getY() {
        return s.getY();
    }
    
    private void jbInit() throws Exception {
        // set up this Displayable to listen to command events
        setCommandListener(this);
        // add the Exit command
        addCommand(new Command("Exit", Command.EXIT, 1));
        addCommand(new Command("Re-Start", Command.OK , 1));
    }
    
    public void run() {
        long t1;
        long t2;
        Graphics g = getGraphics();

        g.setColor(255,255,255);
        g.drawRect(0,0,getWidth(), getHeight());
        s.paint(g);
        
        try {
            
            
            g.setColor(0,0,0);
            g.drawString("Connected",0,0,0);
            
            flushGraphics();
            
            while(true) {
                t1 = System.currentTimeMillis();
               // out.write(10);
               // out.write(100);
               // x++; y++;
                x = 0; y = 0;
                
                int keyStates = getKeyStates();
                if ((keyStates & LEFT_PRESSED) !=0 ) {
                    s.setTransform(s.TRANS_ROT270);
                    x = s.getRefPixelX() - s.getWidth() / 2 - 5 < 0 ? - s.getRefPixelX() + s.getWidth()/2  : -5;
                }
                else if((keyStates & RIGHT_PRESSED) !=0 ) {
                    s.setTransform(s.TRANS_ROT90);
                    x = s.getRefPixelX() + s.getWidth()/2 + 5 > getWidth() ? getWidth() - s.getRefPixelX() - s.getWidth()/2 : 5;
                }
                else if((keyStates & DOWN_PRESSED) !=0 ) {
                    s.setTransform(s.TRANS_ROT180);
                    y = s.getRefPixelY() + s.getHeight()/2 + 5 > getHeight() ? getHeight() - s.getRefPixelY() - s.getHeight()/2 : 5;
                }
                else if((keyStates & UP_PRESSED) !=0 ) {
                    s.setTransform(s.TRANS_NONE);
                    y = s.getRefPixelY() - s.getHeight()/2 - 5 < 0 ? - s.getRefPixelY() + s.getHeight()/2 : -5;
                }
                
                g.setColor(255,255,255);
                g.fillRect(0,0,getWidth(),getHeight());
                
                s.move(x, y);
                s.paint(g);
                
                g.setColor(0,0,0);
                g.drawString("Sprite 1 (" + s.getRefPixelX() + ", " + s.getRefPixelY() + ")", 0, 10, 0 );
                
                flushGraphics();      
                try {
                    t2 = System.currentTimeMillis();
                    Thread.sleep( t2 - t1 < 40 ? 40 - (t2 - t1) : 0 );
                } catch (InterruptedException ie) {} 
            }   
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (command.getCommandType() == Command.EXIT) {
            s1controlMidlet.quitApp();
        }
        /*
        if (command.getCommandType() == Command.OK) {
            // re-start the game
            Thread t = new Thread(this);  //re-start the game in new thread
            t.start();
        }
        */
    }
    
    public void createSprite() {
        Image i = null;
        try {
            i = Image.createImage("/arrow.PNG");
        } catch(Exception e) {}
        
        s = new Sprite(i);
        s.defineReferencePixel(s.getWidth()/2, s.getHeight()/2);
        //x = getWidth()/2;
        //y = getHeight()/2;
        s.setPosition(getWidth()/2, getHeight()/2);
    }
}
